/* 
* ################################################################
* 
* FC2Parser: A Java(TM) parser for FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ package fr.inria.oasis.fc2.parser;

import java.util.ArrayList;


public abstract class Expr implements Cloneable {
    /* Evaluate target lists encoded as
                    + expressions containing only references
       result is of type ArrayList(Integer), as cons elements must be Objects
    */
    ArrayList decode_targets() throws Exception {
        throw new Exception("Expr: bad targets:" + this);
    }

    public int priority() { /* Default: every expression except
           unaries and infixes are -2 */

        return -2;
    }

    public abstract String toString();
        
    public abstract Object dispatch(Visitor visitor, Object[] params);
    
    public abstract Object clone();
    
    public abstract int hashCode();
	public abstract boolean equals(Object obj);
}
