/********************************* Fc2.lex *********************************/
/*                                                                         */
/*    Common Format Lexical analyser                                       */
/*    Compliant to FC2 Version1.1					   */
/*					Eric Madelaine,  April 1994	   */
/*                                                                         */
/*                                                                         */
/* Modified by Tomas Barros 21/10/2002
/***************************************************************************/

package fr.inria.oasis.fc2.parser;

import java_cup.runtime.Symbol;
import java.util.Hashtable;

class Pair {
   int left;
   Object right;

   public Pair (int l, Object r) {
     left = l;
     right = r;
   }
}

class YyUtility {

   private static int token_table_size = 100;
   
   private static Hashtable token_table = new Hashtable(token_table_size);
   
   /* Maps Strings (idents or symbols) to sym(lexical class),String Pairs
      (not Symbols, that should not be shared) */

   static String scan_string (String s, int yyline, int yychar) {
     return s;
   }
   
  // Utility.scan_string should remove the backslash from "\." pairs 
  // fun scan_string (s,pos) =
  //   STRING (process_backslashes (remove_first_and_last s), pos, pos)


   static void add_keyword (String token, String cl, Object val) {
     token_table.put(token, classe_to_pair(cl,val));
   }
   
   static Pair classe_to_pair (String cl, Object val) {
     if (cl.equals("prefix")) { return new Pair(sym.PREFIX,val); }
     if (cl.equals("unary")) { return new Pair(sym.UNARY,val); }
     
     // lot of priorities to add new operators
     
     //operator for default with the maximun priority
     if (cl.equals("infix")) { return new Pair(sym.INFIX,val); }
     
     if (cl.equals("infix50")) { return new Pair(sym.INFIX50,val); }
     if (cl.equals("infix51")) { return new Pair(sym.INFIX51,val); }
     if (cl.equals("infix52")) { return new Pair(sym.INFIX52,val); }
     if (cl.equals("infix53")) { return new Pair(sym.INFIX53,val); }
     if (cl.equals("infix54")) { return new Pair(sym.INFIX54,val); }
     if (cl.equals("infix55")) { return new Pair(sym.INFIX55,val); }
     if (cl.equals("infix56")) { return new Pair(sym.INFIX56,val); }
     if (cl.equals("infix57")) { return new Pair(sym.INFIX57,val); }
     if (cl.equals("infix58")) { return new Pair(sym.INFIX58,val); }
     if (cl.equals("infix59")) { return new Pair(sym.INFIX59,val); }

     if (cl.equals("infix40")) { return new Pair(sym.INFIX40,val); }
     if (cl.equals("infix41")) { return new Pair(sym.INFIX41,val); }
     if (cl.equals("infix42")) { return new Pair(sym.INFIX42,val); }
     if (cl.equals("infix43")) { return new Pair(sym.INFIX43,val); }
     if (cl.equals("infix44")) { return new Pair(sym.INFIX44,val); }
     if (cl.equals("infix45")) { return new Pair(sym.INFIX45,val); }
     if (cl.equals("infix46")) { return new Pair(sym.INFIX46,val); }
     if (cl.equals("infix47")) { return new Pair(sym.INFIX47,val); }
     if (cl.equals("infix48")) { return new Pair(sym.INFIX48,val); }
     if (cl.equals("infix49")) { return new Pair(sym.INFIX49,val); }
     
     if (cl.equals("infix30")) { return new Pair(sym.INFIX30,val); }
     if (cl.equals("infix31")) { return new Pair(sym.INFIX31,val); }
     if (cl.equals("infix32")) { return new Pair(sym.INFIX32,val); }
     if (cl.equals("infix33")) { return new Pair(sym.INFIX33,val); }
     if (cl.equals("infix34")) { return new Pair(sym.INFIX34,val); }
     if (cl.equals("infix35")) { return new Pair(sym.INFIX35,val); }
     if (cl.equals("infix36")) { return new Pair(sym.INFIX36,val); }
     if (cl.equals("infix37")) { return new Pair(sym.INFIX37,val); }
     if (cl.equals("infix38")) { return new Pair(sym.INFIX38,val); }
     if (cl.equals("infix39")) { return new Pair(sym.INFIX39,val); }
     
     if (cl.equals("infix20")) { return new Pair(sym.INFIX20,val); }
     if (cl.equals("infix21")) { return new Pair(sym.INFIX21,val); }
     if (cl.equals("infix22")) { return new Pair(sym.INFIX22,val); }
     if (cl.equals("infix23")) { return new Pair(sym.INFIX23,val); }
     if (cl.equals("infix24")) { return new Pair(sym.INFIX24,val); }
     if (cl.equals("infix25")) { return new Pair(sym.INFIX25,val); }
     if (cl.equals("infix26")) { return new Pair(sym.INFIX26,val); }
     if (cl.equals("infix27")) { return new Pair(sym.INFIX27,val); }
     if (cl.equals("infix28")) { return new Pair(sym.INFIX28,val); }
     if (cl.equals("infix29")) { return new Pair(sym.INFIX29,val); }
     
     if (cl.equals("infix10")) { return new Pair(sym.INFIX10,val); }
     if (cl.equals("infix11")) { return new Pair(sym.INFIX11,val); }
     if (cl.equals("infix12")) { return new Pair(sym.INFIX12,val); }
     if (cl.equals("infix13")) { return new Pair(sym.INFIX13,val); }
     if (cl.equals("infix14")) { return new Pair(sym.INFIX14,val); }
     if (cl.equals("infix15")) { return new Pair(sym.INFIX15,val); }
     if (cl.equals("infix16")) { return new Pair(sym.INFIX16,val); }
     if (cl.equals("infix17")) { return new Pair(sym.INFIX17,val); }
     if (cl.equals("infix18")) { return new Pair(sym.INFIX18,val); }
     if (cl.equals("infix19")) { return new Pair(sym.INFIX19,val); }
    
     
     if (cl.equals("infix0")) { return new Pair(sym.INFIX0,val); }
     if (cl.equals("infix1")) { return new Pair(sym.INFIX1,val); }
     if (cl.equals("infix2")) { return new Pair(sym.INFIX2,val); }
     if (cl.equals("infix3")) { return new Pair(sym.INFIX3,val); }
     if (cl.equals("infix4")) { return new Pair(sym.INFIX4,val); }
     if (cl.equals("infix5")) { return new Pair(sym.INFIX5,val); }
     if (cl.equals("infix6")) { return new Pair(sym.INFIX6,val); }
     if (cl.equals("infix7")) { return new Pair(sym.INFIX7,val); }
     if (cl.equals("infix8")) { return new Pair(sym.INFIX8,val); }
     if (cl.equals("infix9")) { return new Pair(sym.INFIX9,val); }
     
     if (cl.equals("constant")) { return new Pair(sym.CONSTANT,val); }
     if (cl.equals("table_type")) { return new Pair(sym.TABLE_TYPE,val); }
     return new Pair(sym.error,val);
   }

  public static void init_token_table () {
     add_keyword ("B",       "table_type", new Integer(Types.TYPE_BEHAV));
     add_keyword ("behavs",  "table_type", new Integer(Types.TYPE_BEHAV));
     add_keyword ("H",       "table_type", new Integer(Types.TYPE_HOOK));
     add_keyword ("hooks",   "table_type", new Integer(Types.TYPE_HOOK));
     add_keyword ("L",       "table_type", new Integer(Types.TYPE_LOGIC));
     add_keyword ("logics",  "table_type", new Integer(Types.TYPE_LOGIC));
     add_keyword ("S",       "table_type", new Integer(Types.TYPE_STRUCT));
     add_keyword ("structs", "table_type", new Integer(Types.TYPE_STRUCT));
     add_keyword ("tau",     "constant", "t");
     add_keyword ("t",       "constant", "t");
     add_keyword ("quit",    "constant", "q");
     add_keyword ("q",       "constant", "q");
     add_keyword ("_",       "constant", "_");
     add_keyword ("!",       "unary", "!");
     add_keyword ("?",       "unary", "?");
     add_keyword ("~",       "unary", "~");
     add_keyword ("#",       "unary", "#");
     add_keyword ("+",       "infix50", "+");
     add_keyword ("<",       "infix40", "<");
     add_keyword (">",       "infix40", ">");
     add_keyword (",",       "infix30", ",");
     add_keyword (";",       "infix20", ";");
     add_keyword (".",       "infix10", ".");
     add_keyword ("^",       "infix10", "^");
  }

  public static Symbol get_ident (String s, int yyline, int yychar) {
    Pair val = (Pair) token_table.get(s);
    if (null==val) {
      return new Symbol (sym.IDENT, s); }
    else {
      return new Symbol ((int)val.left, val.right); }
  }

  public static Symbol get_symbol (String s, int yyline, int yychar) {
    Pair val = (Pair) token_table.get(s);
    if (null==val) {
      return new Symbol (sym.SYMBOL, s); }
    else {
      return new Symbol ((int)val.left, val.right); }
  }
  
}

%%

%init{
YyUtility.init_token_table();
%init}

%eofval{
  return new Symbol (sym.EOF);
%eofval}

%{
public int getLine() {
  return(yyline);
}
public String getText() {
  return(yytext());
}
%}

%cup
%notunix
%char
%line

symbols = [-,.;'`<>?:~\{\}_=\+!#$^|\\@&()]|"["|"]"
special_symbol	= [%\*"]
digit		= [0-9]
letter	 	= [a-zA-Z]
ws		= [ \t\r\n\f]

stringtext	= (\\\"|[^\n\"]|\\{ws}+\\)*
int		= {digit}+
ident		= {letter}({letter}|_)*

%%
\%.*\n   	{ /* ignore comment line. */ }
{ws}+		{ /* ignore white space. */ }

"->"		{ return new Symbol(sym.ARROW); }
version		{ return new Symbol(sym.VERSION); }
any		{ return new Symbol(sym.ANY); }
b		{ return new Symbol(sym.BEHAV); }
behav		{ return new Symbol(sym.BEHAV); }

C		{ return new Symbol(sym.CONSTANT_DECL); }
constant 	{ return new Symbol(sym.CONSTANT_DECL); }

D		{ return new Symbol(sym.DECLARATIONS); }
declarations    { return new Symbol(sym.DECLARATIONS); }

e		{ return new Symbol(sym.EDGE); }
edge		{ return new Symbol(sym.EDGE); }

E 		{ return new Symbol(sym.EDGES); }
edges		{ return new Symbol(sym.EDGES); }

g		{ return new Symbol(sym.NET); }
graph		{ return new Symbol(sym.NET); }

G 		{ return new Symbol(sym.NETS); }
graphs		{ return new Symbol(sym.NETS); }

h		{ return new Symbol(sym.HOOK); }
hook		{ return new Symbol(sym.HOOK); }

I		{ return new Symbol(sym.INFIX_DECL); }
infix    	{ return new Symbol(sym.INFIX_DECL); }

int	 	{ return new Symbol(sym.INT_TYPE); }

l		{ return new Symbol(sym.LOGIC); }
logic		{ return new Symbol(sym.LOGIC); }

n	  	{ return new Symbol(sym.NET); }
net 	  	{ return new Symbol(sym.NET); }

N	  	{ return new Symbol(sym.NETS); }
nets 	  	{ return new Symbol(sym.NETS); }

P 	  	{ return new Symbol(sym.PREFIX_DECL); }
prefix	  	{ return new Symbol(sym.PREFIX_DECL); }

priority        { return new Symbol(sym.PRIORITY); }

r 	  	{ return new Symbol(sym.RESULT); }
result 	  	{ return new Symbol(sym.RESULT); }

U	  	{ return new Symbol(sym.UNARY_DECL); }
unary	  	{ return new Symbol(sym.UNARY_DECL); }

v	  	{ return new Symbol(sym.VERTEX); }
vertex	  	{ return new Symbol(sym.VERTEX); }

version	  	{ return new Symbol(sym.VERSION); }

V	  	{ return new Symbol(sym.VERTICE); }
vertice	  	{ return new Symbol(sym.VERTICE); }

s	  	{ return new Symbol(sym.STRUCT); }
struct 	  	{ return new Symbol(sym.STRUCT); }

: 	  	{ return new Symbol(sym.COLON); }
\(	  	{ return new Symbol(sym.OP); }
\) 	  	{ return new Symbol(sym.CP); }
@ 	  	{ return new Symbol(sym.REF); }
` 	  	{ return new Symbol(sym.BQUOTE); }


\*	  	{ return new Symbol(sym.STAR, new Integer(1)); }
\*{int}	  	{ return new Symbol(sym.STAR, new Integer(yytext().substring(1))); }

\"{stringtext}\"  	{ return new Symbol(sym.STRING, YyUtility.scan_string(yytext(),yyline,yychar)); }

{int}	  	{ return new Symbol(sym.INT, new Integer(yytext())); }

{symbols}   	{ return YyUtility.get_symbol(yytext(),yyline,yychar); }

{ident}	  	{ return YyUtility.get_ident(yytext(),yyline,yychar); }

. { System.err.println("Illegal character: "+yytext()+" line "+yyline); }



