/********************************* Fc2.lex *********************************/
/*                                                                         */
/*    Common Format Lexical analyser                                       */
/*    Compliant to FC2 Version1.1					   */
/*					Eric Madelaine,  April 1994	   */
/*                                                                         */
/*                                                                         */
/* Modified by Tomas Barros 21/10/2002
/***************************************************************************/
package fr.inria.oasis.fc2.parser;
import java_cup.runtime.Symbol;
import java.util.Hashtable;
class Pair {
   int left;
   Object right;
   public Pair (int l, Object r) {
     left = l;
     right = r;
   }
}
class YyUtility {
   private static int token_table_size = 100;
   private static Hashtable token_table = new Hashtable(token_table_size);
   /* Maps Strings (idents or symbols) to sym(lexical class),String Pairs
      (not Symbols, that should not be shared) */
   static String scan_string (String s, int yyline, int yychar) {
     return s;
   }
  // Utility.scan_string should remove the backslash from "\." pairs 
  // fun scan_string (s,pos) =
  //   STRING (process_backslashes (remove_first_and_last s), pos, pos)
   static void add_keyword (String token, String cl, Object val) {
     token_table.put(token, classe_to_pair(cl,val));
   }
   static Pair classe_to_pair (String cl, Object val) {
     if (cl.equals("prefix")) { return new Pair(sym.PREFIX,val); }
     if (cl.equals("unary")) { return new Pair(sym.UNARY,val); }
     // lot of priorities to add new operators
     //operator for default with the maximun priority
     if (cl.equals("infix")) { return new Pair(sym.INFIX,val); }
     if (cl.equals("infix50")) { return new Pair(sym.INFIX50,val); }
     if (cl.equals("infix51")) { return new Pair(sym.INFIX51,val); }
     if (cl.equals("infix52")) { return new Pair(sym.INFIX52,val); }
     if (cl.equals("infix53")) { return new Pair(sym.INFIX53,val); }
     if (cl.equals("infix54")) { return new Pair(sym.INFIX54,val); }
     if (cl.equals("infix55")) { return new Pair(sym.INFIX55,val); }
     if (cl.equals("infix56")) { return new Pair(sym.INFIX56,val); }
     if (cl.equals("infix57")) { return new Pair(sym.INFIX57,val); }
     if (cl.equals("infix58")) { return new Pair(sym.INFIX58,val); }
     if (cl.equals("infix59")) { return new Pair(sym.INFIX59,val); }
     if (cl.equals("infix40")) { return new Pair(sym.INFIX40,val); }
     if (cl.equals("infix41")) { return new Pair(sym.INFIX41,val); }
     if (cl.equals("infix42")) { return new Pair(sym.INFIX42,val); }
     if (cl.equals("infix43")) { return new Pair(sym.INFIX43,val); }
     if (cl.equals("infix44")) { return new Pair(sym.INFIX44,val); }
     if (cl.equals("infix45")) { return new Pair(sym.INFIX45,val); }
     if (cl.equals("infix46")) { return new Pair(sym.INFIX46,val); }
     if (cl.equals("infix47")) { return new Pair(sym.INFIX47,val); }
     if (cl.equals("infix48")) { return new Pair(sym.INFIX48,val); }
     if (cl.equals("infix49")) { return new Pair(sym.INFIX49,val); }
     if (cl.equals("infix30")) { return new Pair(sym.INFIX30,val); }
     if (cl.equals("infix31")) { return new Pair(sym.INFIX31,val); }
     if (cl.equals("infix32")) { return new Pair(sym.INFIX32,val); }
     if (cl.equals("infix33")) { return new Pair(sym.INFIX33,val); }
     if (cl.equals("infix34")) { return new Pair(sym.INFIX34,val); }
     if (cl.equals("infix35")) { return new Pair(sym.INFIX35,val); }
     if (cl.equals("infix36")) { return new Pair(sym.INFIX36,val); }
     if (cl.equals("infix37")) { return new Pair(sym.INFIX37,val); }
     if (cl.equals("infix38")) { return new Pair(sym.INFIX38,val); }
     if (cl.equals("infix39")) { return new Pair(sym.INFIX39,val); }
     if (cl.equals("infix20")) { return new Pair(sym.INFIX20,val); }
     if (cl.equals("infix21")) { return new Pair(sym.INFIX21,val); }
     if (cl.equals("infix22")) { return new Pair(sym.INFIX22,val); }
     if (cl.equals("infix23")) { return new Pair(sym.INFIX23,val); }
     if (cl.equals("infix24")) { return new Pair(sym.INFIX24,val); }
     if (cl.equals("infix25")) { return new Pair(sym.INFIX25,val); }
     if (cl.equals("infix26")) { return new Pair(sym.INFIX26,val); }
     if (cl.equals("infix27")) { return new Pair(sym.INFIX27,val); }
     if (cl.equals("infix28")) { return new Pair(sym.INFIX28,val); }
     if (cl.equals("infix29")) { return new Pair(sym.INFIX29,val); }
     if (cl.equals("infix10")) { return new Pair(sym.INFIX10,val); }
     if (cl.equals("infix11")) { return new Pair(sym.INFIX11,val); }
     if (cl.equals("infix12")) { return new Pair(sym.INFIX12,val); }
     if (cl.equals("infix13")) { return new Pair(sym.INFIX13,val); }
     if (cl.equals("infix14")) { return new Pair(sym.INFIX14,val); }
     if (cl.equals("infix15")) { return new Pair(sym.INFIX15,val); }
     if (cl.equals("infix16")) { return new Pair(sym.INFIX16,val); }
     if (cl.equals("infix17")) { return new Pair(sym.INFIX17,val); }
     if (cl.equals("infix18")) { return new Pair(sym.INFIX18,val); }
     if (cl.equals("infix19")) { return new Pair(sym.INFIX19,val); }
     if (cl.equals("infix0")) { return new Pair(sym.INFIX0,val); }
     if (cl.equals("infix1")) { return new Pair(sym.INFIX1,val); }
     if (cl.equals("infix2")) { return new Pair(sym.INFIX2,val); }
     if (cl.equals("infix3")) { return new Pair(sym.INFIX3,val); }
     if (cl.equals("infix4")) { return new Pair(sym.INFIX4,val); }
     if (cl.equals("infix5")) { return new Pair(sym.INFIX5,val); }
     if (cl.equals("infix6")) { return new Pair(sym.INFIX6,val); }
     if (cl.equals("infix7")) { return new Pair(sym.INFIX7,val); }
     if (cl.equals("infix8")) { return new Pair(sym.INFIX8,val); }
     if (cl.equals("infix9")) { return new Pair(sym.INFIX9,val); }
     if (cl.equals("constant")) { return new Pair(sym.CONSTANT,val); }
     if (cl.equals("table_type")) { return new Pair(sym.TABLE_TYPE,val); }
     return new Pair(sym.error,val);
   }
  public static void init_token_table () {
     add_keyword ("B",       "table_type", new Integer(Types.TYPE_BEHAV));
     add_keyword ("behavs",  "table_type", new Integer(Types.TYPE_BEHAV));
     add_keyword ("H",       "table_type", new Integer(Types.TYPE_HOOK));
     add_keyword ("hooks",   "table_type", new Integer(Types.TYPE_HOOK));
     add_keyword ("L",       "table_type", new Integer(Types.TYPE_LOGIC));
     add_keyword ("logics",  "table_type", new Integer(Types.TYPE_LOGIC));
     add_keyword ("S",       "table_type", new Integer(Types.TYPE_STRUCT));
     add_keyword ("structs", "table_type", new Integer(Types.TYPE_STRUCT));
     add_keyword ("tau",     "constant", "t");
     add_keyword ("t",       "constant", "t");
     add_keyword ("quit",    "constant", "q");
     add_keyword ("q",       "constant", "q");
     add_keyword ("_",       "constant", "_");
     add_keyword ("!",       "unary", "!");
     add_keyword ("?",       "unary", "?");
     add_keyword ("~",       "unary", "~");
     add_keyword ("#",       "unary", "#");
     add_keyword ("+",       "infix50", "+");
     add_keyword ("<",       "infix40", "<");
     add_keyword (">",       "infix40", ">");
     add_keyword (",",       "infix30", ",");
     add_keyword (";",       "infix20", ";");
     add_keyword (".",       "infix10", ".");
     add_keyword ("^",       "infix10", "^");
  }
  public static Symbol get_ident (String s, int yyline, int yychar) {
    Pair val = (Pair) token_table.get(s);
    if (null==val) {
      return new Symbol (sym.IDENT, s); }
    else {
      return new Symbol ((int)val.left, val.right); }
  }
  public static Symbol get_symbol (String s, int yyline, int yychar) {
    Pair val = (Pair) token_table.get(s);
    if (null==val) {
      return new Symbol (sym.SYMBOL, s); }
    else {
      return new Symbol ((int)val.left, val.right); }
  }
}


class Yylex implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

public int getLine() {
  return(yyline);
}
public String getText() {
  return(yytext());
}
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yychar;
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	Yylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	Yylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Yylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yychar = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;

YyUtility.init_token_table();
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int yy_state_dtrans[] = {
		0
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yychar = yychar
			+ yy_buffer_index - yy_buffer_start;
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NOT_ACCEPT,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NOT_ACCEPT,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NOT_ACCEPT,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NOT_ACCEPT,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NOT_ACCEPT,
		/* 70 */ YY_NO_ANCHOR,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NO_ANCHOR,
		/* 73 */ YY_NO_ANCHOR,
		/* 74 */ YY_NO_ANCHOR,
		/* 75 */ YY_NO_ANCHOR,
		/* 76 */ YY_NO_ANCHOR,
		/* 77 */ YY_NO_ANCHOR,
		/* 78 */ YY_NO_ANCHOR,
		/* 79 */ YY_NO_ANCHOR,
		/* 80 */ YY_NO_ANCHOR,
		/* 81 */ YY_NO_ANCHOR,
		/* 82 */ YY_NO_ANCHOR,
		/* 83 */ YY_NO_ANCHOR,
		/* 84 */ YY_NO_ANCHOR,
		/* 85 */ YY_NO_ANCHOR,
		/* 86 */ YY_NO_ANCHOR,
		/* 87 */ YY_NO_ANCHOR,
		/* 88 */ YY_NO_ANCHOR,
		/* 89 */ YY_NO_ANCHOR,
		/* 90 */ YY_NO_ANCHOR,
		/* 91 */ YY_NO_ANCHOR,
		/* 92 */ YY_NO_ANCHOR,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NO_ANCHOR,
		/* 95 */ YY_NO_ANCHOR,
		/* 96 */ YY_NO_ANCHOR,
		/* 97 */ YY_NO_ANCHOR,
		/* 98 */ YY_NO_ANCHOR,
		/* 99 */ YY_NO_ANCHOR,
		/* 100 */ YY_NO_ANCHOR,
		/* 101 */ YY_NO_ANCHOR,
		/* 102 */ YY_NO_ANCHOR,
		/* 103 */ YY_NO_ANCHOR,
		/* 104 */ YY_NO_ANCHOR,
		/* 105 */ YY_NO_ANCHOR,
		/* 106 */ YY_NO_ANCHOR,
		/* 107 */ YY_NO_ANCHOR,
		/* 108 */ YY_NO_ANCHOR,
		/* 109 */ YY_NO_ANCHOR,
		/* 110 */ YY_NO_ANCHOR,
		/* 111 */ YY_NO_ANCHOR,
		/* 112 */ YY_NO_ANCHOR,
		/* 113 */ YY_NO_ANCHOR,
		/* 114 */ YY_NO_ANCHOR,
		/* 115 */ YY_NO_ANCHOR,
		/* 116 */ YY_NO_ANCHOR,
		/* 117 */ YY_NO_ANCHOR,
		/* 118 */ YY_NO_ANCHOR,
		/* 119 */ YY_NO_ANCHOR,
		/* 120 */ YY_NO_ANCHOR,
		/* 121 */ YY_NO_ANCHOR,
		/* 122 */ YY_NO_ANCHOR,
		/* 123 */ YY_NO_ANCHOR,
		/* 124 */ YY_NO_ANCHOR,
		/* 125 */ YY_NO_ANCHOR,
		/* 126 */ YY_NO_ANCHOR,
		/* 127 */ YY_NO_ANCHOR,
		/* 128 */ YY_NO_ANCHOR,
		/* 129 */ YY_NO_ANCHOR,
		/* 130 */ YY_NO_ANCHOR,
		/* 131 */ YY_NO_ANCHOR,
		/* 132 */ YY_NO_ANCHOR,
		/* 133 */ YY_NO_ANCHOR,
		/* 134 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"2:9,4,3,2,4,5,2:18,4,47,45,47:2,1,47:2,39,40,43,47:2,6,47,2,44:10,38,47:3,7" +
",47,41,48:2,19,22,26,48,28,48,30,48:4,33,48,34,48:4,36,37,48:4,47,46,47:2,4" +
"9,42,15,17,20,23,9,31,25,18,12,48,29,24,48,14,13,27,48,10,11,21,35,8,48,32," +
"16,48,47:4,2,0:2")[0];

	private int yy_rmap[] = unpackFromString(1,135,
"0,1,2,3,4,5,6,7,8,9,10,11,12,13:2,14,15,13:7,1:5,16,17,1:2,16,1,13,18,13,19" +
",13:6,20,13:11,2,1:2,21,22:3,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,3" +
"8,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,6" +
"3,64,65,66,67,68,69,70,71,72,73,13,74,75,76,77,78,79,80,81,82,83,84,85,86,8" +
"7,88,89,90,91,92")[0];

	private int yy_nxt[][] = unpackFromString(93,50,
"1,2,58,3:3,4,59,5,6,7,8,9,115,10,124,115,11,12,13,127,115,14,128,15,16,17,1" +
"29,18,115,19,115:2,20,21,130,22,23,24,25,26,27,28,29,30,63,59:2,115,59,-1:5" +
"1,57:2,31,57,-1,57:44,-1:3,3:3,-1:51,32,-1:50,115,131,115:28,-1:10,115:2,-1" +
":8,115:15,132,115:14,-1:10,115:2,-1:8,115,133,115:28,-1:10,115:2,-1:8,115:1" +
"3,134,115:16,-1:10,115:2,-1:8,115:6,60,115:23,-1:10,115:2,-1:8,115,64,115:2" +
"8,-1:10,115:2,-1:8,115,68,115:28,-1:10,115:2,-1:8,115:5,70,115:24,-1:10,115" +
":2,-1:8,115:30,-1:10,115:2,-1:8,115:5,73,115:24,-1:10,115:2,-1:8,115:2,74,1" +
"15:27,-1:10,115:2,-1:44,33,-1:49,30,-1:13,115:3,39,115:26,-1:10,115:2,-1:8," +
"115:3,41,115:26,-1:10,115:2,-1:8,115:3,50,115:26,-1:10,115:2,-1:8,115:13,35" +
",115:9,79,115:6,-1:10,115:2,-1,62:2,-1,62:41,34,65,62:3,-1:8,115:13,36,115:" +
"16,-1:10,115:2,-1,62:2,67,69:2,62:39,61,65,62:3,-1:8,115:8,37,115:21,-1:10," +
"115:2,-1:3,67:3,-1:40,62,-1:11,115:10,125,115:19,-1:10,115:2,-1,62:2,67,69:" +
"2,62:39,34,65,62:3,-1:8,115:5,80,115:24,-1:10,115:2,-1:8,115:6,81,115:23,-1" +
":10,115:2,-1:8,115:12,82,115:17,-1:10,115:2,-1:8,115:17,118,115:12,-1:10,11" +
"5:2,-1:8,115:7,83,115:22,-1:10,115:2,-1:8,115,84,115:2,85,115:25,-1:10,115:" +
"2,-1:8,115:3,126,115:9,87,115:16,-1:10,115:2,-1:8,115,38,115:28,-1:10,115:2" +
",-1:8,115:27,119,115:2,-1:10,115:2,-1:8,115:4,89,115:25,-1:10,115:2,-1:8,11" +
"5:21,40,115:8,-1:10,115:2,-1:8,115:3,91,115:26,-1:10,115:2,-1:8,115:16,92,1" +
"15:13,-1:10,115:2,-1:8,115:19,94,115:10,-1:10,115:2,-1:8,115:23,95,115:6,-1" +
":10,115:2,-1:8,115:5,120,115:24,-1:10,115:2,-1:8,115:2,96,115:27,-1:10,115:" +
"2,-1:8,115,98,115:2,121,115:25,-1:10,115:2,-1:8,115:12,100,115:17,-1:10,115" +
":2,-1:8,115:24,42,115:5,-1:10,115:2,-1:8,43,115:29,-1:10,115:2,-1:8,115:13," +
"122,115:16,-1:10,115:2,-1:8,115:7,101,115:22,-1:10,115:2,-1:8,115:12,44,115" +
":17,-1:10,115:2,-1:8,115:10,45,115:19,-1:10,115:2,-1:8,115:4,102,115:25,-1:" +
"10,115:2,-1:8,115:8,46,115:21,-1:10,115:2,-1:8,115:5,104,115:24,-1:10,115:2" +
",-1:8,115:24,47,115:5,-1:10,115:2,-1:8,115:13,48,115:16,-1:10,115:2,-1:8,11" +
"5:13,49,115:16,-1:10,115:2,-1:8,115:2,107,115:27,-1:10,115:2,-1:8,115:24,51" +
",115:5,-1:10,115:2,-1:8,115:4,108,115:25,-1:10,115:2,-1:8,115:6,52,115:23,-" +
"1:10,115:2,-1:8,115,53,115:28,-1:10,115:2,-1:8,115:6,109,115:23,-1:10,115:2" +
",-1:8,115:7,123,115:22,-1:10,115:2,-1:8,115:13,110,115:16,-1:10,115:2,-1:8," +
"115:13,54,115:16,-1:10,115:2,-1:8,115:8,55,115:21,-1:10,115:2,-1:8,115:4,11" +
"2,115:25,-1:10,115:2,-1:8,115:5,113,115:24,-1:10,115:2,-1:8,115:6,114,115:2" +
"3,-1:10,115:2,-1:8,115:3,56,115:26,-1:10,115:2,-1:8,115:7,86,115:22,-1:10,1" +
"15:2,-1:8,115:27,88,115:2,-1:10,115:2,-1:8,115:4,93,115:25,-1:10,115:2,-1:8" +
",115:16,99,115:13,-1:10,115:2,-1:8,115:2,103,115:27,-1:10,115:2,-1:8,115:12" +
",105,115:17,-1:10,115:2,-1:8,115:7,106,115:22,-1:10,115:2,-1:8,115:13,111,1" +
"15:16,-1:10,115:2,-1:8,115:6,66,115:23,-1:10,115:2,-1:8,115:7,90,115:22,-1:" +
"10,115:2,-1:8,115:4,97,115:25,-1:10,115:2,-1:8,115:5,71,115:24,-1:10,115:2," +
"-1:8,115,72,115:28,-1:10,115:2,-1:8,115:2,75,115:27,-1:10,115:2,-1:8,115:6," +
"116,115:23,-1:10,115:2,-1:8,115:2,76,115:27,-1:10,115:2,-1:8,115:17,77,115:" +
"12,-1:10,115:2,-1:8,115:3,78,115:26,-1:10,115:2,-1:8,115:2,117,115:27,-1:10" +
",115:2");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

  return new Symbol (sym.EOF);
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ System.err.println("Illegal character: "+yytext()+" line "+yyline); }
					case -3:
						break;
					case 3:
						{ /* ignore white space. */ }
					case -4:
						break;
					case 4:
						{ return YyUtility.get_symbol(yytext(),yyline,yychar); }
					case -5:
						break;
					case 5:
						{ return new Symbol(sym.VERTEX); }
					case -6:
						break;
					case 6:
						{ return new Symbol(sym.EDGE); }
					case -7:
						break;
					case 7:
						{ return new Symbol(sym.RESULT); }
					case -8:
						break;
					case 8:
						{ return new Symbol(sym.STRUCT); }
					case -9:
						break;
					case 9:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -10:
						break;
					case 10:
						{ return new Symbol(sym.NET); }
					case -11:
						break;
					case 11:
						{ return new Symbol(sym.BEHAV); }
					case -12:
						break;
					case 12:
						{ return new Symbol(sym.HOOK); }
					case -13:
						break;
					case 13:
						{ return new Symbol(sym.CONSTANT_DECL); }
					case -14:
						break;
					case 14:
						{ return new Symbol(sym.DECLARATIONS); }
					case -15:
						break;
					case 15:
						{ return new Symbol(sym.LOGIC); }
					case -16:
						break;
					case 16:
						{ return new Symbol(sym.NET); }
					case -17:
						break;
					case 17:
						{ return new Symbol(sym.EDGES); }
					case -18:
						break;
					case 18:
						{ return new Symbol(sym.NETS); }
					case -19:
						break;
					case 19:
						{ return new Symbol(sym.INFIX_DECL); }
					case -20:
						break;
					case 20:
						{ return new Symbol(sym.NETS); }
					case -21:
						break;
					case 21:
						{ return new Symbol(sym.PREFIX_DECL); }
					case -22:
						break;
					case 22:
						{ return new Symbol(sym.UNARY_DECL); }
					case -23:
						break;
					case 23:
						{ return new Symbol(sym.VERTICE); }
					case -24:
						break;
					case 24:
						{ return new Symbol(sym.COLON); }
					case -25:
						break;
					case 25:
						{ return new Symbol(sym.OP); }
					case -26:
						break;
					case 26:
						{ return new Symbol(sym.CP); }
					case -27:
						break;
					case 27:
						{ return new Symbol(sym.REF); }
					case -28:
						break;
					case 28:
						{ return new Symbol(sym.BQUOTE); }
					case -29:
						break;
					case 29:
						{ return new Symbol(sym.STAR, new Integer(1)); }
					case -30:
						break;
					case 30:
						{ return new Symbol(sym.INT, new Integer(yytext())); }
					case -31:
						break;
					case 31:
						{ /* ignore comment line. */ }
					case -32:
						break;
					case 32:
						{ return new Symbol(sym.ARROW); }
					case -33:
						break;
					case 33:
						{ return new Symbol(sym.STAR, new Integer(yytext().substring(1))); }
					case -34:
						break;
					case 34:
						{ return new Symbol(sym.STRING, YyUtility.scan_string(yytext(),yyline,yychar)); }
					case -35:
						break;
					case 35:
						{ return new Symbol(sym.INT_TYPE); }
					case -36:
						break;
					case 36:
						{ return new Symbol(sym.NET); }
					case -37:
						break;
					case 37:
						{ return new Symbol(sym.ANY); }
					case -38:
						break;
					case 38:
						{ return new Symbol(sym.EDGE); }
					case -39:
						break;
					case 39:
						{ return new Symbol(sym.NETS); }
					case -40:
						break;
					case 40:
						{ return new Symbol(sym.HOOK); }
					case -41:
						break;
					case 41:
						{ return new Symbol(sym.EDGES); }
					case -42:
						break;
					case 42:
						{ return new Symbol(sym.INFIX_DECL); }
					case -43:
						break;
					case 43:
						{ return new Symbol(sym.BEHAV); }
					case -44:
						break;
					case 44:
						{ return new Symbol(sym.LOGIC); }
					case -45:
						break;
					case 45:
						{ return new Symbol(sym.NET); }
					case -46:
						break;
					case 46:
						{ return new Symbol(sym.UNARY_DECL); }
					case -47:
						break;
					case 47:
						{ return new Symbol(sym.VERTEX); }
					case -48:
						break;
					case 48:
						{ return new Symbol(sym.RESULT); }
					case -49:
						break;
					case 49:
						{ return new Symbol(sym.STRUCT); }
					case -50:
						break;
					case 50:
						{ return new Symbol(sym.NETS); }
					case -51:
						break;
					case 51:
						{ return new Symbol(sym.PREFIX_DECL); }
					case -52:
						break;
					case 52:
						{ return new Symbol(sym.VERSION); }
					case -53:
						break;
					case 53:
						{ return new Symbol(sym.VERTICE); }
					case -54:
						break;
					case 54:
						{ return new Symbol(sym.CONSTANT_DECL); }
					case -55:
						break;
					case 55:
						{ return new Symbol(sym.PRIORITY); }
					case -56:
						break;
					case 56:
						{ return new Symbol(sym.DECLARATIONS); }
					case -57:
						break;
					case 58:
						{ System.err.println("Illegal character: "+yytext()+" line "+yyline); }
					case -58:
						break;
					case 59:
						{ return YyUtility.get_symbol(yytext(),yyline,yychar); }
					case -59:
						break;
					case 60:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -60:
						break;
					case 61:
						{ return new Symbol(sym.STRING, YyUtility.scan_string(yytext(),yyline,yychar)); }
					case -61:
						break;
					case 63:
						{ System.err.println("Illegal character: "+yytext()+" line "+yyline); }
					case -62:
						break;
					case 64:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -63:
						break;
					case 66:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -64:
						break;
					case 68:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -65:
						break;
					case 70:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -66:
						break;
					case 71:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -67:
						break;
					case 72:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -68:
						break;
					case 73:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -69:
						break;
					case 74:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -70:
						break;
					case 75:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -71:
						break;
					case 76:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -72:
						break;
					case 77:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -73:
						break;
					case 78:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -74:
						break;
					case 79:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -75:
						break;
					case 80:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -76:
						break;
					case 81:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -77:
						break;
					case 82:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -78:
						break;
					case 83:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -79:
						break;
					case 84:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -80:
						break;
					case 85:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -81:
						break;
					case 86:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -82:
						break;
					case 87:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -83:
						break;
					case 88:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -84:
						break;
					case 89:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -85:
						break;
					case 90:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -86:
						break;
					case 91:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -87:
						break;
					case 92:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -88:
						break;
					case 93:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -89:
						break;
					case 94:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -90:
						break;
					case 95:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -91:
						break;
					case 96:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -92:
						break;
					case 97:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -93:
						break;
					case 98:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -94:
						break;
					case 99:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -95:
						break;
					case 100:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -96:
						break;
					case 101:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -97:
						break;
					case 102:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -98:
						break;
					case 103:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -99:
						break;
					case 104:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -100:
						break;
					case 105:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -101:
						break;
					case 106:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -102:
						break;
					case 107:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -103:
						break;
					case 108:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -104:
						break;
					case 109:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -105:
						break;
					case 110:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -106:
						break;
					case 111:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -107:
						break;
					case 112:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -108:
						break;
					case 113:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -109:
						break;
					case 114:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -110:
						break;
					case 115:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -111:
						break;
					case 116:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -112:
						break;
					case 117:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -113:
						break;
					case 118:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -114:
						break;
					case 119:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -115:
						break;
					case 120:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -116:
						break;
					case 121:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -117:
						break;
					case 122:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -118:
						break;
					case 123:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -119:
						break;
					case 124:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -120:
						break;
					case 125:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -121:
						break;
					case 126:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -122:
						break;
					case 127:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -123:
						break;
					case 128:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -124:
						break;
					case 129:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -125:
						break;
					case 130:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -126:
						break;
					case 131:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -127:
						break;
					case 132:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -128:
						break;
					case 133:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -129:
						break;
					case 134:
						{ return YyUtility.get_ident(yytext(),yyline,yychar); }
					case -130:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
