/* 
* ################################################################
* 
* FC2Parser: A Java(TM) parser for FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 
package fr.inria.oasis.fc2.parser;

public class Fc2String extends Expr {
    protected String value;

    public Fc2String(String s) {
        value = s;
    }

    public Object clone() {
        return (new Fc2String(new String(value)));
    }
    
    public int hashCode() {
    	if (value == null) return(0);
    	return(value.hashCode());
    }

    public String toString() {
        return value;
    }

    public boolean equals(Object o) {
        if (o == null) {
            return (false);
        }

        if (o instanceof Fc2String) {
            return (equals((Fc2String) o));
        }

        return (false);
    }

    public boolean equals(Fc2String string) {
        if (string == null) {
            return (false);
        }

        if ((string.getValue() == null) && (value == null)) {
            return true;
        }

        if ((string.getValue() != null) && string.getValue().equals(value)) {
            return true;
        }

        return false;
    }

    /**
     * @return String
     */
    public String getValue() {
        return value;
    }

    /**
     * Sets the value.
     * @param value The value to set
     */
    public void setValue(String value) {
        this.value = value;
    }

    public Object dispatch(Visitor visitor, Object[] params) {
        return (visitor.visit(this, params));
    }
}
