/* 
* ################################################################
* 
* FC2Parser: A Java(TM) parser for FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 
package fr.inria.oasis.fc2.parser;

public class Idle extends Expr {
    protected int value;

    public Idle(int i) {
        value = i;
    }

    public Object clone() {
        return (new Idle(value));
    }

    public int hashCode() {
        return (value);
    }

    public String toString() {
        if (value == 1) {
            return ("*");
        } else {
            return ("*" + value);
        }
    }

    public boolean equals(Object o) {
        if (o == null) {
            return (false);
        }

        if (o instanceof Idle) {
            return (equals((Idle) o));
        }

        return (false);
    }

    public boolean equals(Idle idle) {
        if (idle == null) {
            return (false);
        }

        if (idle.getValue() == value) {
            return (true);
        }

        return (false);
    }

    /**
     * @return int
     */
    public int getValue() {
        return value;
    }

    /**
     * Sets the value.
     * @param value The value to set
     */
    public void setValue(int value) {
        this.value = value;
    }

    public Object dispatch(Visitor visitor, Object[] params) {
        return (visitor.visit(this, params));
    }
}
