/* 
* ################################################################
* 
* FC2Parser: A Java(TM) parser for FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 
package fr.inria.oasis.fc2.parser;

import java.util.ArrayList;


public class Ref extends Expr {
    protected int value;

    public Ref(int i) {
        value = i;
    }

    public Object clone() {
        return (new Ref(value));
    }

    public String toString() {
        return (String.valueOf(value));
    }
    
    public int hashCode() {
    	return(value);
    }

    ArrayList decode_targets() throws Exception {
        ArrayList l = new ArrayList(1);
        l.add(0, new Integer(value));

        return l;
    }

    public boolean equals(Object o) {
        if (o == null) {
            return (false);
        }

        if (o instanceof Ref) {
            if (getValue() == ((Ref) o).getValue()) {
                return (true);
            }
        }

        return (false);
    }

    public boolean equals(Ref ref) {
        if (ref == null) {
            return (false);
        }

        if (value == ref.getValue()) {
            return (true);
        }

        return (false);
    }

    /**
     * @return int
     */
    public int getValue() {
        return value;
    }

    /**
     * Sets the value.
     * @param value The value to set
     */
    public void setValue(int value) {
        this.value = value;
    }

    public Object dispatch(Visitor visitor, Object[] params) {
        return (visitor.visit(this, params));
    }
}
