/* 
* ################################################################
* 
* FC2Parameterized: A Java(TM) interpreter for Parameterized FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 

package fr.inria.oasis.fc2;


/**
 * @author tbarros
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Mapping {
    Mapping parent;
    Object key;
    Object value;

    public Mapping() {
        parent = null;
    }

    public Mapping(Mapping parent, Object key, Object value) {
        this.parent = parent;
        this.key = key;
        this.value = value;
    }

    public int hashCode() {
    	if (parent == null)
        return (value.hashCode() + key.hashCode());
        else
		return (value.hashCode() + (key.hashCode()<<4)+(parent.hashCode()<<8));        
    }

    public boolean equals(Object obj) {
        if (obj == null) {
            return (false);
        }

        try {
            Mapping mobj = (Mapping) obj;

            if ((mobj.getKey() == null) && (key == null) &&
                    (mobj.getValue() == null) && (value == null)) {
                return (true);
            }

            if (((key == null) ? (mobj.getKey() == null)
                                   : key.equals(mobj.getKey())) &&
                    ((value == null) ? (mobj.getValue() == null)
                                         : value.equals(mobj.getValue())) &&
                    ((parent == null) ? (mobj.getParent() == null)
                                          : parent.equals(mobj.getParent()))) {
                return (true);
            }

            return (false);
        } catch (ClassCastException e) {
            return (false);
        }
    }

    public Object get(Object key) {
        if (this.key.equals(key)) {
            return (value);
        }

        if ((parent == null) || (parent.parent == null)) {
            return (null);
        }

        return (parent.get(key));
    }

    /**
     * @return
     */
    public Mapping getParent() {
        return parent;
    }

    /**
     * @param mapping
     */
    public void setParent(Mapping mapping) {
        parent = mapping;
    }

    public String toString() {
    	String result = null;
    	
    	if (value instanceof String) {
			result = key + " => \"" + value+"\"";
    	} else {
			result = key + " => " + value;
    	}

        if ((parent == null) || (parent.parent == null)) {
            return (result);
        } else {
            return (parent.toString() + ",\n" + result);
        }
    }

    /**
     * @return
     */
    public Object getKey() {
        return key;
    }

    /**
     * @return
     */
    public Object getValue() {
        return value;
    }
}
