/* 
* ################################################################
* 
* FC2Parameterized: A Java(TM) interpreter for Parameterized FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 

package fr.inria.oasis.fc2;

import fr.inria.oasis.fc2.parser.Bquote;
import fr.inria.oasis.fc2.parser.Fc2String;
import fr.inria.oasis.fc2.parser.GlobalRef;
import fr.inria.oasis.fc2.parser.Idle;
import fr.inria.oasis.fc2.parser.OpExpr;
import fr.inria.oasis.fc2.parser.Ref;
import fr.inria.oasis.fc2.parser.Visitor;



/**
 * @author tbarros
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class MergeInstancesVisitor implements Visitor {
    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.Visitor#visit(fr.inria.oasis.fc2.parser.OpExpr, java.lang.Object[])
     */
	protected static final MathSolverVisitor mathSolverVisitor = new MathSolverVisitor();

    public Object visit(OpExpr exp, Object[] params) {

        if (",".equals(exp.getOp())) {
        	// OpExpr nExpr = (OpExpr)exp.clone();
			// nExpr.getSons()[0] = (Expr)nExpr.getSons()[0].dispatch(this, new Object[] { values });
			// nExpr.getSons()[1] = (Expr)nExpr.getSons()[1].dispatch(this, new Object[] { values });
            return (new Value(exp.getSons()[0].dispatch(this, params),exp.getSons()[1].dispatch(this, params)));
        }

        Object ref = exp.dispatch(mathSolverVisitor, params);

        //if (ref == null) {
          //  return (null);
        //}

		// return (new AnyRef(ref));
		return (ref);
    }

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.Visitor#visit(fr.inria.oasis.fc2.parser.Fc2String, java.lang.Object[])
     */
    public Object visit(Fc2String exp, Object[] params) {
		// return (new AnyRef(exp.dispatch(mathSolverVisitor, params)));
		return (exp.dispatch(mathSolverVisitor, params));
    }

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.Visitor#visit(fr.inria.oasis.fc2.parser.Ref, java.lang.Object[])
     */
    public Object visit(Ref exp, Object[] params) {
		// return (new AnyRef(exp.dispatch(mathSolverVisitor, params)));
		return (exp.dispatch(mathSolverVisitor, params));
    }

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.Visitor#visit(fr.inria.oasis.fc2.parser.GlobalRef, java.lang.Object[])
     */
    public Object visit(GlobalRef exp, Object[] params) {
		// return (new AnyRef(exp.dispatch(mathSolverVisitor, params)));
		return (exp.dispatch(mathSolverVisitor, params));
    }

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.Visitor#visit(fr.inria.oasis.fc2.parser.Bquote, java.lang.Object[])
     */
    public Object visit(Bquote exp, Object[] params) {
		// return (new AnyRef(exp.dispatch(mathSolverVisitor, params)));
		return (exp.dispatch(mathSolverVisitor, params));
    }

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.Visitor#visit(fr.inria.oasis.fc2.parser.Idle, java.lang.Object[])
     */
    public Object visit(Idle exp, Object[] params) {
		// return (new AnyRef(exp.dispatch(mathSolverVisitor, params)));
		return (exp.dispatch(mathSolverVisitor, params));
    }
}
