/* 
* ################################################################
* 
* FC2Parameterized: A Java(TM) interpreter for Parameterized FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 

package fr.inria.oasis.fc2;

import fr.inria.oasis.fc2.parser.Expr;



/**
 * @author bbarros
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ReferencesStrategy extends StrategyAbstractImplementation {
    protected static final MergeInstancesVisitor mergeInstancesVisitor = new MergeInstancesVisitor();
    public int offset;
    protected Reference reference;
    protected Expr variables;

	public ReferencesStrategy(Expr variables) {
		this.offset = 0;
		this.variables = variables;
		reference = new Reference();
	}

	public ReferencesStrategy(Expr variables, int hashSize) {
		this.offset = 0;
		this.variables = variables;
		reference = new Reference(hashSize);
	}

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.StrategyAbstractImplementation#execute(fr.inria.oasis.fc2.parser.Mapping)
     */
    public void execute(Mapping map) {
        // TODO Auto-generated method stub
        if (variables == null) {
        	reference.put("",new Integer(offset++));
        	return;
        }
        
        Object val = variables.dispatch(mergeInstancesVisitor,
                new Object[] { map });
                
        if (val == null) {
            Utils.reportError(
                "There is not evaluation for the variables reference " + val +
                " for the variables " + variables);
        } else {
            reference.put(val, new Integer(offset));
            offset++;
        }
    }

    /**
     * @return
     */
    public int getOffset() {
        return offset;
    }
	/**
	 * @return
	 */
	public Reference getReference() {
		return reference;
	}

}
