/* 
* ################################################################
* 
* FC2Parameterized: A Java(TM) interpreter for Parameterized FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 

package fr.inria.oasis.fc2;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

import fr.inria.oasis.fc2.parser.Expr;


/**
 * @author tbarros
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ResultMathStrategy extends StrategyTableAbstractImplementation {
    protected static final MergeInstancesVisitor mergeInstancesVisitor = new MergeInstancesVisitor();
    protected ArrayList result;

	public ResultMathStrategy(PrintStream netOut, PrintStream infoOut) {
		super(netOut,infoOut);
		result = new ArrayList();
	}
	
    public ResultMathStrategy(Object preFix, int offset, PrintStream netOut, PrintStream infoOut) {
    	super(preFix,0,netOut,infoOut);
		result = new ArrayList();
    }
    
	public StrategyTableAbstractImplementation make(Object preFix, int offset) {
		return(new ResultMathStrategy(preFix,offset,netOut,infoOut));
	}

    /* (non-Javadoc)
     * @see fr.inria.oasis.fc2.parser.StrategyTableAbstractImplementation#execute(fr.inria.oasis.fc2.parser.Mapping)
     */
    public void execute(Mapping map) {
        // TODO Auto-generated method stub
        if (getVariables() == null) {
			Utils.reportError(
				"The expresion exp is not a valid math expresion or variable name");
            return;
        }

        Expr exp = getVariables();
        Object val = exp.dispatch(mergeInstancesVisitor, new Object[] { map });

        if (val == null) {
            Utils.reportError(
                "There is not evaluation for the variables reference " + val +
                " for the variables " + variables);
        } else {
        	result.add(val);
        }
    }
    
    
	/**
	 * @return
	 */
	public List getResult() {
		return result;
	}

}
