/* 
* ################################################################
* 
* FC2Parameterized: A Java(TM) interpreter for Parameterized FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 

package fr.inria.oasis.fc2;

import java.util.ArrayList;
import java.util.List;

import fr.inria.oasis.fc2.parser.OpExpr;


/**
 * @author bbarros
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public abstract class StrategyAbstractImplementation implements Strategy {
    public static final MathSolverVisitor mathSolverVisitor = new MathSolverVisitor();
    public static final StrategySetMathSolverVisitor strategySetMathSolverVisitor =
        new StrategySetMathSolverVisitor();
        
    public abstract void execute(Mapping map);

    public void go(List assign, Mapping map) {
    	if (map == null) map = new Mapping();
    	
        if (assign.size() == 0) {
            execute(map);

            return;
        }
        
        List newList = new ArrayList(assign);

        Object o = newList.remove(0);

        if (o instanceof OpExpr) {
            OpExpr exp = (OpExpr) o;

            if ("when".equals(exp.getOp())) {
                Boolean result = (Boolean) exp.getSons()[0].dispatch(mathSolverVisitor,
                        new Object[] { map });

                if (!result.booleanValue()) {
                    return;
                }

                go(newList, map);

                return;
            }

            if ("=".equals(exp.getOp())) {

                exp.getSons()[1].dispatch(strategySetMathSolverVisitor,
                        new Object[] {
                            map, ((OpExpr) exp.getSons()[0]).getOp(), this,
                            newList
                        });

                return;
            }
        }

        go(newList, map);
    }
}
