/* 
* ################################################################
* 
* FC2Parameterized: A Java(TM) interpreter for Parameterized FC2 Format files
* 
* Copyright (C) 2004 INRIA
* Contact: vercors@sophia.inria.fr
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*  
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*  
*  Initial developer(s):               Oasis Project
*                        http://www.inria.fr/oasis
*  Contributor(s): 
* 
* ################################################################
*/ 

package fr.inria.oasis.fc2;


/**
 * @author tbarros
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Value {
    public Object left;
    public Object rigth;
    private int hashCode;

    public Value(Object left, Object rigth) {
        this.left = left;
        this.rigth = rigth;
        hashCode = 1 + ((left == null) ? 0 : (left.hashCode() << 5)) +
            ((rigth == null) ? 0 : rigth.hashCode());
    }

    public int hashCode() {
        return (hashCode);
    }

    public boolean equals(Object o) {
        if (o == null) {
            return (false);
        }

        try {
            Value expr = (Value) o;

            if (((left == null) ? (expr.getLeft() == null)
                                    : left.equals(expr.getLeft())) &&
                    ((rigth == null) ? (expr.getRigth() == null)
                                         : rigth.equals(expr.getRigth()))) {
                return (true);
            }
        } catch (ClassCastException e) {
            return (false);
        }

        return (false);
    }

    public String toString() {
        return (left + "," + rigth);
    }

    /**
     * @return
     */
    public Object getLeft() {
        return left;
    }

    /**
     * @return
     */
    public Object getRigth() {
        return rigth;
    }
}
